## 
# Random Events Event Manager class
# Author - David Fidge
# 
# Version 1.0
#

## CvRandomEventsEventManager
## This class is passed an argsList from CvAppInterface.onEvent
## The argsList can contain anything from mouse location to key info
## The EVENTLIST that are being notified can be found 

# the CvRandomEventsEventManager inherits from CvEventManager class
# better than overriding the CvEventManger file because if Firaxis ever change the base CvEventManager file then
# nothing needs to be done

#add in

import CvEventManager
import RandomEvents	
	

# globals
###################################################
class CvRandomEventsEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)

                #the random events instance
                #this is created when civ 4 c++ code calls the CvEventInterface file
                self.randomEvents = RandomEvents.RandomEvents()	


	def onGameStart(self, argsList):
		'Called at the start of the game'
		self.parent.onGameStart(self, argsList)

		#upon starting a new game game, initialise the random events screen
		
		self.randomEvents.handleOnGameStart(argsList)
	
	def onBeginGameTurn(self, argsList):
		iGameTurn = argsList[0]
		self.parent.onBeginGameTurn(self, argsList)

		#do random turn processing.  This involves creating a new random event or updating random events
		#that are currently in place

		self.randomEvents.handleOnBeginGameTurn(iGameTurn)

	def onLoadGame(self, argsList):

		#upon loading a new game game, initialise the random events screen
		self.parent.onLoadGame(self, argsList)

		self.randomEvents.handleOnLoadGame(argsList)
		return 0


	def onTechAcquired(self, argsList):

		self.parent.onTechAcquired(self, argsList)
		'Tech Acquired'

		self.randomEvents.handleOnTechAcquired(argsList)

