## 
# Religious Tour Event
# Author - David Fidge
# 
# Version 1.1
# - this event not yet in
#

from CvPythonExtensions import *
from RandomEventsConstants import *
from CvRandomEventsScreenEnums import *
import CvRandomEventsScreenUtils
import GlobalFunctions

import RandomEventsIO
import RandomEventsScreen

import CvUtil
import PyHelpers

import random
import math

#import CvScreenEnums

PyPlayer = PyHelpers.PyPlayer
PyCity = PyHelpers.PyCity
GlobalFunctions = GlobalFunctions.GlobalFunctions()
gc = CyGlobalContext()
CyMapInstance = gc.getMap()
CyGameInstance = gc.getGame()


#the main class

class RandomEventReligiousTour:
	"Earthquake Event Class"
	
	#class initialisation (called on creation of the class instance within CvScreensInterface)
	
	def __init__(self, io):

		#holds city and visited flags - [citypointer, bool]
		self.citylist = []
		self.religionChosen = -1

		#set the io object - should always be done last as a reminder to not use the object yet 
		#as game may have not started

		self.IOinstance = io

	#initialise the mod.  This is called when loading a game or starting a new game

	def initialise(self):

	def checkEra(self):


	def changeToModern(self):




	def showScreen(self):

	def setupTour(self):

		self.citylist = []
		activatedReligions = []

		maxreligions = gc.getNumReligionInfos()


		#loop through all religions and pick out those that have been founded
		for x in range (0 to maxreligions):
			if (CyGameInstance.isReligionFounded(x)):
				activatedReligions.append(x)

		if (len(activatedReligions) == 0):

			#get a list of all cities that follow this religion

        		self.religionChosen = random.randint(0, len(activatedReligions)-1)
        
        		allcities = GlobalFunctions.getAllCities()
        
        		for c in allcities:
        			
        			if (c.isHasReligion(self.religionChosen)):
        			
        				self.citylist.append(c,0)
        
        		if (len(self.citylist) == 0):

				#this religion has no cities with the religion active, return false

				return false

		else:

			#no religions discovered, return false

			return false

		return true
	

	def turnChecker(self, iTurnNum):
		"this is called every turn.  Checks to see if the earthquake event should occur this turn"
		
		#CvUtil.pyPrint("entered turnchecker")

		#the chance of an earthquake is only determined every EARTHQUAKE_DELAY turns

		if (iTurnNum % EARTHQUAKE_DELAY == 0):

			randnum = random.randint(1, EARTHQUAKE_MAX_CHANCE)

			#CvUtil.pyPrint("random number for swarm is " + str(randnum))
			
			if (randnum <= EARTHQUAKE_CHANCE_LIMIT):

				setupSuccess = false

        			setupSuccess = self.setUpEarthquake()
        
				if (setupSuccess == true):
					self.checkEra()
							
					self.showScreen()

