## 
# Random Events Constants File
# Author - David Fidge
# Version 1.4
# - reduced duration of droughts
# Version 1.3
# - added drought stuff
# - added fertility stuff
# Version 1.2
# - added volcano stuff 
# - removed constants that are no longer needed now that I have discovered how to get them in-game
# Version 1.1
# - added earthquakes
# - removed popup constants
# Version 1.0
# - initial release

from CvPythonExtensions import *   #need this for true/false

#####################
#misc flags
#####################

#change this to false if you dont want the camera to centre on the event
CENTRE_CAMERA_ON_EVENT = true


######################
#enable flags
#if you dont want a particular event, change to false
######################

ENABLE_OLYMPICS = true
ENABLE_LOCUSTSWARM = true
ENABLE_EARTHQUAKE = true
ENABLE_VOLCANO = true
ENABLE_DROUGHT = true
ENABLE_FERTILE = true

#############################
#OLYMPICS EVENT CONSTANTS
#############################

#the eras
OLYMPICS_ANCIENT_ERA = 0
OLYMPICS_MODERN_ERA = 1

#colosseum ID is the order in which it appears in the CIV4BuildingInfos.xml file
#so palace has an ID of 0
#if you count from palace to colosseum you will get the number 28
#formula to find out building ID's from xml file is 
#(start line number of building entry in xml file / 146) - 1
#NO LONGER USED
#OLYMPICS_COLOSSEUM_ID = 28  
OLYMPICS_POPULATION_LIMIT = 10
OLYMPICS_CULTURE_BONUS = 0.10
OLYMPICS_POPULATION_BONUS = 1

#time (in turns) between olympics during ancient era
OLYMPICS_ANCIENT_DELAY = 3#35

#time (in turns) between olympics in modern era
OLYMPICS_MODERN_DELAY = 3#15

#the value for certain variables if there's no applicable olympic city
OLYMPICS_NO_OLYMPIC_CITY = -1

#############################
#LOCUST SWARM EVENT CONSTANTS
#############################

#with the below settings there is a 1 in 15 chance that a locust swarm will happen every 20 turns
#this means it should happen around 2-4 times a game
#how often the locust random event is checked
LOCUSTSWARM_LOCUST_DELAY = 1#20
#a dice roll between 1 and MAX_CHANCE is made to determine if there will be a Swarm this turn
LOCUSTSWARM_MAX_CHANCE = 1#15
#if the dice roll <= CHANCE_LIMIT then there will be a locust Swarm
LOCUSTSWARM_CHANCE_LIMIT = 1

############################
#EARTHQUAKE CONSTANTS
############################

#with settings below there is a 1 in 60 chance of an earthquake every turn
EARTHQUAKE_DELAY = 1
EARTHQUAKE_MAX_CHANCE = 60
EARTHQUAKE_CHANCE_LIMIT = 1

#do not change maxpower
EARTHQUAKE_MAXPOWER = 100

#earthquakes between 0-EARTHQUAKE_SEVERITY1 cause no damage
EARTHQUAKE_SEVERITY1 = 40
#earthquakes between EARTHQUAKE_SEVERITY1-EARTHQUAKE_SEVERITY2 cause some damage
EARTHQUAKE_SEVERITY2 = 70
#earthquakes between EARTHQUAKE_SEVERITY2-EARTHQUAKE_SEVERITY3 cause much damage
EARTHQUAKE_SEVERITY3 = 90
#earthquakes between EARTHQUAKE_SEVERITY3-EARTHQUAKE_MAXPOWER cause incredible damage

#do not change these
EARTHQUAKE_PRE_SEISMIC_ERA = 0
EARTHQUAKE_POST_SEISMIC_ERA = 1


#############################
#VOLCANO EVENT CONSTANTS
#############################

#How often a volcano creation check is done
VOLCANO_CREATE_DELAY = 2#17
#a dice roll between 1 and MAX_CHANCE is made to determine if there will be a volcano
VOLCANO_CREATE_MAX_CHANCE = 1#10
#if the dice roll <= VOLCANO_CREATE_CHANCE_LIMIT then there will be a volcano
VOLCANO_CREATE_CHANCE_LIMIT = 1

#How often a volcano boom check is done
VOLCANO_BOOM_DELAY = 2#5
#a dice roll between 1 and MAX_CHANCE is made to determine if there will be a volcano
VOLCANO_BOOM_MAX_CHANCE = 1#15
#if the dice roll <= VOLCANO_CREATE_CHANCE_LIMIT then there will be a volcano
VOLCANO_BOOM_CHANCE_LIMIT = 1

#Volcano names to use
VOLCANO_NAMES= ('Mnt. Vesuvius', 'White Island', 'Teide', 'Tambora', 'Surtsey', 'Mnt. St. Helens', 'Mnt. Shasta', 'Mnt Rainier', 'Stromboli', 'Soufriere Hills', 'Santorini', 'Popocatepetl', 'Mnt. Pinatubo', 'Paricutin', 'Novarupta', 'El Misti', 'Mauna Loa', 'Mauna Kea', 'Krakatoa', 'Kluchevskaya', 'Kilauea', 'Kick-\'em-Jenny', 'Hekla', 'Kratla', 'Etna', 'Mnt. Erebus', 'Mnt. Hood', 'Mount Fuji', 'Cotopaxi', 'Pico de Orizaba', 'El Chichon', 'Cold Bay', 'Mnt. Baker')

#between 0 to (squareroot(number of squares) / VOLCANO_DENSITY) at the start of the game
VOLCANO_DENSITY=20

#when a volcano booms, city population is lost.  Amount of loss is population / VOLCANO_POP_MODIFIER
VOLCANO_POP_MODIFIER = 3


##########################
#DROUGHT EVENT CONSTANTS
##########################

#droughts last between DROUGHT_MAXLENGTH/2 to DROUGHT_MAXLENGTH turns
DROUGHT_MAXLENGTH = 8

#radius of drought (how many squares from centre the drought extends each way) - random value between min and max
DROUGHT_MINRADIUS = 2
DROUGHT_MAXRADIUS = 5

#How often a drought creation check is done
DROUGHT_DELAY = 1
#a dice roll between 1 and MAX_CHANCE is made to determine if there will be a drought
DROUGHT_MAX_CHANCE = 60
#if the dice roll <= DROUGHT_CHANCE_LIMIT then there will be a drought
DROUGHT_CHANCE_LIMIT = 1



##########################
#FERTILE EVENT CONSTANTS
##########################

#fertility last between FERTILE_MAXLENGTH/2 to FERTILE_MAXLENGTH turns
FERTILE_MAXLENGTH = 12

#radius of drought (how many squares from centre the drought extends each way) - random value between min and max
FERTILE_MINRADIUS = 2
FERTILE_MAXRADIUS = 5

#How often a drought creation check is done
FERTILE_DELAY = 1
#a dice roll between 1 and MAX_CHANCE is made to determine if there will be fertility
FERTILE_MAX_CHANCE = 60
#if the dice roll <= FERTILE_CHANCE_LIMIT then there will be a fertility
FERTILE_CHANCE_LIMIT = 1