## 
# Random Events IO class
# Author - David Fidge
# Version 1.2
# - added volcanos
# Version 1.1
# - added support for loading in variables from previous versions of the mod
# Version 1.0
# - initial release




#import utility functions
from CvPythonExtensions import *
import pickle
import CvUtil			

# globals
gc = CyGlobalContext()
CyGameInstance = gc.getGame()

class RandomEventsIO:

	def setupScriptDataNewGame( self ):
		"Initialise the global script data dictionary for usage in a NEW GAME"

		#this needs to hold all variables to be saved between games

		scriptDictCyGame = 	{	'olympicCounter': 1,
						'locustSwarmOccupyingPlotX': -1,  #-1 denotes no swarm currently in play
						'locustSwarmOccupyingPlotY': -1,
						'numVolcanos': -1,
						'droughtTuple': (-1,-1,-1),
						'fertileTuple': (-1,-1,-1)						
					}

		CyGameInstance.setScriptData( pickle.dumps(scriptDictCyGame) )

	def setupScriptDataLoadGame(self):
		"Initialise the global script data dictionary for usage in an EXISTING LOADED GAME"
		"THIS FUNCTION BRINGS AN OLDER SAVE GAME VERSION OF THE RANDOM EVENTS MOD UP TO DATE"

		"NOTE - FOR WHATEVER REASON THIS DOESNT WORK SO I AM NO LONGER USING THIS FUNCTION"
		
		#load in data from cygame
			
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )

		#store the length

		scriptDataLength = len(scriptDictCyGame)
		#CvUtil.pyPrint("length of script data array: " + str(scriptDataLength))

		NUM_VARIABLES = 6	#this number must be equal to number of variables in setupScriptDataNewGame

		for x in range(NUM_VARIABLES+1):
			#CvUtil.pyPrint("now processing variable: " + str(x))

			#if the length of the data loaded in from getScriptData is less then the number of variables that should be in it, then append an initialisation value for missing variables
			if (x > scriptDataLength):
				if (x == 1):
					scriptDictCyGame.append({'olympicCounter': 1})
				elif (x == 2):
					scriptDictCyGame.append({'locustSwarmOccupyingPlotX': -1})
				elif (x == 3):
					scriptDictCyGame.append({'locustSwarmOccupyingPlotY': -1})
				elif (x == 4):
					scriptDictCyGame.append({'numVolcanos': 0})  #this is 0 rather than -1 so that when an old version game is loaded, volcanoes arent created
				elif (x == 5):
					scriptDictCyGame.append({'droughtTuple': (-1,-1,-1)})
				elif (x == 6):
					scriptDictCyGame.append({'fertileTuple': (-1,-1,-1)})					

		#CvUtil.pyPrint("NEW length of script data array: " + str(scriptDataLength))
		CyGameInstance.setScriptData( pickle.dumps(scriptDictCyGame) )

	def getOlympicCounter( self ):
		"Returns olympicCounter"
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		return scriptDictCyGame['olympicCounter']

	def setOlympicCounter( self, newValue ):
		"Sets olympicCounter."
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		scriptDictCyGame['olympicCounter'] = newValue
		CyGameInstance.setScriptData( pickle.dumps(scriptDictCyGame) )

	def getLocustSwarmOccupyingPlot(self):
		"get the plot the locust swarm is occupying"
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		return scriptDictCyGame['locustSwarmOccupyingPlotX'], scriptDictCyGame['locustSwarmOccupyingPlotY']		

	def setLocustSwarmOccupyingPlot(self, x, y):
		"sets the plot the locust swarm is occupying"
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		scriptDictCyGame['locustSwarmOccupyingPlotX'] = x
		scriptDictCyGame['locustSwarmOccupyingPlotY'] = y
		CyGameInstance.setScriptData( pickle.dumps(scriptDictCyGame) )

	def getNumVolcanos(self):
		"Gets how many volcanos we have"
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		return scriptDictCyGame['numVolcanos']
		
	def setNumVolcanos( self, newValue ):
		"Sets NumVolcanos."
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		scriptDictCyGame['numVolcanos'] = newValue
		CyGameInstance.setScriptData( pickle.dumps(scriptDictCyGame) )

	def getDroughtTuple(self):
		"Gets drought plot and length"
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		return scriptDictCyGame['droughtTuple']
		
	def setDroughtTuple( self, newTuple ):
		"Sets drought plot and length."
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		scriptDictCyGame['droughtTuple'] = newTuple
		CyGameInstance.setScriptData( pickle.dumps(scriptDictCyGame) )

	def getFertileTuple(self):
		"Gets drought plot and length"
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		return scriptDictCyGame['fertileTuple']

	def setFertileTuple( self, newTuple ):
		"Sets drought plot and length."
		scriptDictCyGame = pickle.loads( CyGameInstance.getScriptData() )
		scriptDictCyGame['fertileTuple'] = newTuple
		CyGameInstance.setScriptData( pickle.dumps(scriptDictCyGame) )
	

	


     
