#
# Sniper Mod
# SniperUtils
# 

from CvPythonExtensions import *
import CvUtil

import sys
import PyHelpers
import CvConfigParser
import TheLopezUtils
import math
import time
import pickle

# globals
###################################################

#######SD Tool Kit#######

import SdToolKit
sdEcho         = SdToolKit.sdEcho
sdModInit      = SdToolKit.sdModInit
sdModLoad      = SdToolKit.sdModLoad
sdModSave      = SdToolKit.sdModSave
sdEntityInit   = SdToolKit.sdEntityInit
sdEntityExists = SdToolKit.sdEntityExists
sdGetVal       = SdToolKit.sdGetVal
sdSetVal       = SdToolKit.sdSetVal
sdEntityWipe   = SdToolKit.sdEntityWipe

############################

# globals
###################################################
gc = CyGlobalContext()	

PyPlayer = PyHelpers.PyPlayer
PyGame = PyHelpers.PyGame()
localText = CyTranslator()


# Change this to enable or disable hills giving snipers a greater line of sight 
# and increasing their sniper range by one.
# Default value is true
g_bHillsIncreaseSniperRange = true

# Change this to enable or disable snipers ability to see through terrain like
# forests, hills, peaks, etc.
# Default value is false
g_bSnipersSeeThroughTerrain = False

# Change this to false if the sniper range should only be displayed when the 
# take shot action has been enabled.
# Default value is False
g_bAlwaysDisplaySniperRanges = False

# Change this to display or hide the snipers shooting range.
# Default value is true
g_bDisplaySniperShootingRange = True

# Change this to change the color that will be used to highlight the snipers
# shooting range. 
# Default value is "COLOR_BLUE"
g_strSniperShootingRangeColor = "COLOR_BLUE"

# Change this to display or hide the snipers visibility range.
# Default value is true
g_bDisplaySniperVisibilityRange = True

# Change this to change the color that will be used to highlight the snipers
# visibility range. 
# Default value is "COLOR_RED"
g_strSniperVisibilityRangeColor = "COLOR_RED"

# Change this to enable or disable the sniper harassing action. When enabled it
# will allow the harassing action which functions much like sentry except for
# that snipers put in the harassing state will fire at any enemy units that 
# come into its range.
# Default value is true
g_bEnableSniperHarassing = true

# Change this to increase or decrease the number of shots snipers have when 
# they are set to the harass mode.
# Default value is 6
g_iSniperHarassShotCount = 6

# Change this to false prevent snipers from shooting at plots with no enemy 
# units.
# Default value is False
g_bAllowSniperWasteShot = False

# Change this to false if snipers should not be allowed to target anything 
# inside a city including units, citizens, specialists and super specialists.
# Default value is True
g_bAllowSniperTargetCities = true

# Change this to false if snipers should not be allowed to target specialists
# inside cities.
# Default value is true
g_bAllowSniperTargetSpecialists = true

# Change this to false if snipers should not be allowed to target super 
# specialists inside cities.
# Default value is true
g_bAllowSniperTargetSuperSpecialists = true

# Change this to false if snipers should not be allowed to terrorize citizens
# inside cities.
# Default value is true
g_bAllowSniperTerrorizeCitizens = true

# Change this to increase or decrease the base sniper aim amount.
# Default value is 25
g_iBaseSniperAim = 25

# Change this to increase or decrease the base sniper fatal shot amount.
# Default value is 25
g_iBaseSniperFatalShot = 25

# Change this to increase or decrease the base sniper obfuscation amount.
# Default value is 25
g_iBaseSniperObfuscation = 25

# Change this to give sniper units experience for all successful shots fatal
# and non-fatal.
# Default value is false
g_bAllShotsGiveExperience = false

# Change this to increase or decrease the number of experience points sniper
# units get per successful shot. A successful shot is defined as either a 
# shot that hurts or kills the intended target.
# Default value is 1
g_iExperiencePerSuccessfulShot = 1

# Change this to false if forests should not affect the obfuscation rate for
# snipers.
# Default value is true
g_bForestsAffectObfuscation = true

# Change this to increase or decrease the amount that forests affect the 
# obfuscation amount for snipers.
# Default value is 15
g_iForestObfuscationEffectAmount = 15

# Change this to false if jungles should not affect the obfuscation rate for 
# snipers.
# Default value is true
g_bJunglesAffectObfuscation = true

# Change this to increase or decrease the amount that jungles affect the 
# obfuscation amount for snipers.
# Default value is 15
g_iJungleObfuscationEffectAmount = 15

# Change this to true if hills should affect the obfuscation rate for snipers.
# Default value is false
g_bHillsAffectObfuscation = false

# Change this to increase or decrease the amount that hills affect the 
# obfuscation amount for snipers.
# Default value is 10
g_iHillObfuscationEffectAmount = 10

SNIPER_DATA = "SNIPERDATA" 
OWNER_ID = "OWNERID" 
SNIPER_ID = "SNIPERID"
OLD_PLOT = "OLDPLOT"
NEW_PLOT = "NEWPLOT"
DISCOVERED = "DISCOVERED"
LAST_OBFUSCATION_RESULT = "LASTOBFUSCATIONRESULT"
SNIPER_HARASSING = "SNIPER_HARASSING"
SNIPER_HARASSING_SHOTS = "SNIPER_HARASSING_SHOTS"
FATAL_SHOT = "FATAL_SHOT"
AIM = "AIM"
OBFUSCATION = "OBFUSCATION"

g_SniperPromotions = { AIM: { "PROMOTION_AIM1" : 8,
							  "PROMOTION_AIM2" : 15,
							  "PROMOTION_AIM3" : 13,
							  "PROMOTION_AIM4" : 10,
							  "PROMOTION_AIM5" : 8 } ,
					   FATAL_SHOT: { "PROMOTION_FATAL_SHOT1" : 12,
									 "PROMOTION_FATAL_SHOT2" : 15,
									 "PROMOTION_FATAL_SHOT3" : 7 },
					   OBFUSCATION: { "PROMOTION_OBFUSCATION1" : 20,
									 "PROMOTION_OBFUSCATION2" : 24,
									 "PROMOTION_OBFUSCATION3" : 16 }
					}
							
							
# Set to true to print out debug messages in the logs
g_bDebug = false

LOG_ONLY = 1
SCREEN_ONLY = 2
LOG_AND_SCREEN = 3

# Change to redirect the debug messages to the logs, screen or both.
g_iDebugMessageTarget = LOG_ONLY

					
class SniperUtils:
	
	def __init__(self):
		# initialize base class
		
		global g_bHillsIncreaseSniperRange
		global g_bSnipersSeeThroughTerrain
		global g_bAlwaysDisplaySniperRanges
		global g_bDisplaySniperShootingRange
		global g_strSniperShootingRangeColor
		global g_bDisplaySniperVisibilityRange
		global g_strSniperVisibilityRangeColor
		global g_bEnableSniperHarassing
		global g_iSniperHarassShotCount
		global g_bAllowSniperWasteShot
		global g_bAllowSniperTargetCities
		global g_bAllowSniperTargetSpecialists
		global g_bAllowSniperTargetSuperSpecialists
		global g_bAllowSniperTerrorizeCitizens
		global g_iBaseSniperAim
		global g_iBaseSniperFatalShot		
		global g_iBaseSniperObfuscation
		global g_bAllShotsGiveExperience 
		global g_iExperiencePerSuccessfulShot
		global g_bForestsAffectObfuscation
		global g_iForestObfuscationEffectAmount
		global g_bJunglesAffectObfuscation
		global g_iJungleObfuscationEffectAmount
		global g_bHillsAffectObfuscation
		global g_iHillObfuscationEffectAmount
				
		config = CvConfigParser.CvConfigParser("Sniper Mod Config.ini")

		if(config != None):
			g_bHillsIncreaseSniperRange = config.getboolean("Sniper Mod", "Hills Increase Sniper Range", True)
			g_bSnipersSeeThroughTerrain = config.getboolean("Sniper Mod", "Snipers See Through Terrain", False)
			g_bAlwaysDisplaySniperRanges = config.getboolean("Sniper Mod", "Always Display Sniper Ranges", False)
			g_bDisplaySniperShootingRange = config.getboolean("Sniper Mod", "Display Sniper Shooting Range", True)
			g_strSniperShootingRangeColor = config.get("Sniper Mod", "Sniper Shooting Range Color", "COLOR_BLUE")
			g_bDisplaySniperVisibilityRange = config.getboolean("Sniper Mod", "Display Sniper Visibility Range", True)
			g_strSniperVisibilityRangeColor = config.get("Sniper Mod","Sniper Visibility Range Color", "COLOR_RED")
			g_bEnableSniperHarassing = config.getboolean("Sniper Mod", "Enable Sniper Harassing", True)			
			g_iSniperHarassShotCount = config.getint("Sniper Mod", "Sniper Harass Shot Count",6) 			
			g_bAllowSniperWasteShot = config.getboolean("Sniper Mod", "Allow Sniper Waste Shot", True)
			g_bAllowSniperTargetCities = config.getboolean("Sniper Mod", "Allow Sniper Target Cities", True)
			g_bAllowSniperTargetSpecialists = config.getboolean("Sniper Mod", "Allow Sniper Target Specialists", True)
			g_bAllowSniperTargetSuperSpecialists = config.getboolean("Sniper Mod", "Allow Sniper Target Super Specialists", True)
			g_bAllowSniperTerrorizeCitizens = config.getboolean("Sniper Mod", "Allow Sniper Terrorize Citizens", True)
			g_iBaseSniperAim = config.getint("Sniper Mod", "Base Sniper Aim", 25)
			g_iBaseSniperFatalShot = config.getint("Sniper Mod", "Base Sniper Fatal Shot", 25)			
			g_iBaseSniperObfuscation = config.getint("Sniper Mod", "Base Sniper Obfuscation", 25)
			g_bAllShotsGiveExperience = config.getboolean("Sniper Mod", "All Shots Give Experience", false)
			g_iExperiencePerSuccessfulShot = config.getint("Sniper Mod", "Experience Per Successful Shot", 1)
			g_bForestsAffectObfuscation = config.getboolean("Sniper Mod", "Forests Affect Obfuscation", True)
			g_iForestObfuscationEffectAmount = config.getint("Sniper Mod", "Forest Obfuscation Effect Amount",15)
			g_bJunglesAffectObfuscation = config.getboolean("Sniper Mod", "Jungles Affect Obfuscation", True)
			g_iJungleObfuscationEffectAmount = config.getint("Sniper Mod", "Jungle Obfuscation Effect Amount",15)
			g_bHillsAffectObfuscation = config.getboolean("Sniper Mod", "Hills Affect Obfuscation", False)
			g_iHillObfuscationEffectAmount = config.getint("Sniper Mod", "Hill Obfuscation Effect Amount",10)
					
	
	# Displays the appropriate sniper highlighting depending on how the mod has
	# been configured.		
	def handleSniperPlotHighlighting(self, bTakeShot):

		# Clear all of the appropriate plot layers
		CyEngine().clearColoredPlots(PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_REVEALED_PLOTS)
		CyEngine().clearColoredPlots(PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_HIGHLIGHT_PLOTS)
		
		# Get the selected unit
		objUnit = CyInterface().getHeadSelectedUnit()
		
		# Return immediately if no units are selected
		if(objUnit == None):
			return 

		# Return immediately if the unit selected isn't a sniper.			
		if(objUnit.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return 
			
		# Get the sniper's shooting range.
		iSniperShootingRange = objUnit.getExtraVisibilityRange()

		# If the sniper's shooting range is zero or negative set it to one
		if(iSniperShootingRange <= 0):
			iSniperShootingRange = 1

		# Get the sniper's visibility range
		iSniperVisibilityRange = objUnit.visibilityRange()
			
		bDisplaySniperRanges = bTakeShot
		
		if(g_bAlwaysDisplaySniperRanges):
			bDisplaySniperRanges = true

		if(bDisplaySniperRanges):
			# Show the sniper visiblity range if the mod is configured to do so
			if(g_bDisplaySniperVisibilityRange):
				self.highlightSniperRange(objUnit, iSniperVisibilityRange, PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_HIGHLIGHT_PLOTS, g_strSniperVisibilityRangeColor)

			# Show the sniper shooting range if the mod is configured to do so
			if(g_bDisplaySniperShootingRange):
				self.highlightSniperRange(objUnit, iSniperShootingRange, PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_REVEALED_PLOTS, g_strSniperShootingRangeColor)
	
			
	# Highlights the plots for the sniper extending out for the range passed 
	# in. The highlighted plots will be on the layer passed in the color 
	# passed in.
	def highlightSniperRange(self, objSniper, iRange, iPlotLayer, strColor):
	
		# Return immediately if the sniper passed in is invalid
		if(objSniper == None):
			return
			
		# Return immediately if the range passed in is invalid
		if(iRange <= 0):
			return
			
		# Get the plot the sniper is on.
		objSniperPlot = objSniper.plot()

		# Get the valid plots for the sniper		
		sniperTargetPlotList = self.getSniperTargetPlots(objSniper, iRange)
		
		# Go through the valid target plots
		for objTargetPlot in sniperTargetPlotList:
			
			# Get the distance between the sniper and the target plot.
			iDistance = TheLopezUtils.getPlotDistance(objSniperPlot, objTargetPlot)

			# Calculate the alpha value using the range and the distance
			dAlpha = 0.1 + (0.1 * float((iRange + 1) - iDistance))

			# If the line of sight isn't blocked to the target plot then 
			# highlight the target plot. This shouldn't be needed since the 
			# getSniperTargetPlots method already checks for this condition.
			if(not self.isLineOfSightBlocked(objSniperPlot,objTargetPlot)):
				CyEngine().addColoredPlotAlt(objTargetPlot.getX(), objTargetPlot.getY(), PlotStyles.PLOT_STYLE_BOX_FILL, iPlotLayer, strColor, dAlpha)
			

	# Gives or removes the line of sight promotion to the unit passed in.
	def setLineOfSight(self, objUnit):

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
	
		# Get the plot the sniper is on
		objPlot = objUnit.plot()
		
		# Give the line of sight promotion if the plot the sniper is on a hill.
		if(objPlot.isHills() and g_bHillsIncreaseSniperRange):
			objUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_LINE_OF_SIGHT"), true)

		# Remove the line of sight promotion if the plot the sniper is not on a 
		# hill.
		elif(not objPlot.isHills() and g_bHillsIncreaseSniperRange):
			objUnit.setHasPromotion(gc.getInfoTypeForString("PROMOTION_LINE_OF_SIGHT"), false)
			
			
	# Returns the list of plots adjacent to the unit passed in.
	def getAdjacentPlots(self, objUnit):
		adjacentPlotList = []
		
		# Return an empty list immediately if the unit passed in is invalid
		if(objUnit == None):
			return []
			
		# Return an empty list immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return []
		
		# Get the plot the sniper is on
		objUnitPlot = objUnit.plot()

		# Get the snipers owner's team
		iPlayerTeam = gc.getPlayer(objUnit.getOwner()).getTeam()
	
		# Calculate the extents of plots to check
		iMinX = objUnitPlot.getX() - 1
		iMaxX = objUnitPlot.getX() + 2
		iMinY = objUnitPlot.getY() - 1
		iMaxY = objUnitPlot.getY() + 2
	
		# Go through the x values of plots to check
		for iX in range(iMinX, iMaxX):
			# Go through the y values of plots to check
			for iY in range(iMinY, iMaxY):

				# Continue on to the next plot if the current x,y value pair is
				# for the plot the unit is on.
				if(iX == objUnit.getX() and iY == objUnit.getY()):
					continue
				
				# Continue on to the next plot if the Y value is negative
				if(iY < 0):
					continue
					
				# Continue on to the next plot if the Y value is greater than
				# the height of the map
				if(iY > gc.getMap().getGridHeight()):
					continue
	
				# Get the actual plot on the map using the x,y value pair				
				objTargetPlot = CyMap().plot(iX, iY)

				# Continue on if the target plot isn't revealed to the player
				if(not objTargetPlot.isRevealed(iPlayerTeam, false)):
					continue

				# Continue on if the plot isn't visible to the player
				if(not objTargetPlot.isVisible(iPlayerTeam, false)):
					continue

				adjacentPlotList.append(objTargetPlot)

		return adjacentPlotList


	# Returns the closest sniper to that is actively harassing 	
	def getClosestHarassingSniper(self, objUnit):
		
		# Return None immediately if the unit passed in is invalid
		if(objUnit == None):
			return None
			 
		# Return None immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return None

		# Get the team the unit belongs to
		objUnitTeam = gc.getTeam(objUnit.getTeam())
	
		# Get a large number of plots that could contain snipers
		plotList = self.getSniperTargetPlots(objUnit, 4)
	
		objClosestSniper = None
		iClosestSniperDistance = 999
		
		# Go through the list of plots
		for objPlot in plotList:
		
			# Get the list of units in the current plot
			unitList = TheLopezUtils.getPlotUnitList(objPlot)
			
			# Go through the list of units
			for objTempUnit in unitList:
			
				# Continue if the current unit isn't a sniper
				if(objTempUnit.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
					continue
				
				# Continue if the current unit's team isn't at war with the 
				# unit passed in.
				if(not objUnitTeam.isAtWar(objTempUnit.getTeam())):
					continue
				
				# Get the sniper data for the current unit
				sniperData = self.getSniperData(objTempUnit)
				
				# Continue if the current unit isn't a sniper that is currently
				# harassing
				if(not sniperData[SNIPER_HARASSING]):
					continue
					
				# Continue if the current unit is a sniper that is harassing 
				# but has run out of shots
				if(sniperData[SNIPER_HARASSING_SHOTS] == 0):
					continue
				
				# Get the distance between the current unit and the unit 
				# passed in
				iTempDistance = TheLopezUtils.getUnitDistance(objUnit, objTempUnit)
				
				# If the current unit is closer then set them as the unit to 
				# return
				if(iTempDistance < iClosestSniperDistance):
					iClosestSniperDistance = iTempDistance
					objClosestSniper = objTempUnit
		
		return objClosestSniper


	# Returns true if the sniper can harass units false otherwise.	
	def canSniperHarassUnits(self, objSniper):
		# Return false if the harassing feature is not enabled
		if(not g_bEnableSniperHarassing):
			return false 
			
		# Return false immediately if the sniper passed in is invalid
		if(objSniper == None):
			return false

		# Return false immediately if the sniper passed in is invalid
		if(objSniper.isNone()):
			return false
	
		# Return false if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return false
			
		# Return false if the sniper cannot move
		if(not objSniper.canMove()):
			return false 
		
		# Return false if the sniper isn't awake
		if(objSniper.getGroup().getActivityType() != ActivityTypes.ACTIVITY_AWAKE and not self.isSniperHarassingEnabled(objSniper)):
			return false

		# Get the sniper data
		sniperData = self.getSniperData(objSniper)

		# Return false if the sniper has no more harassment shots left
		if(sniperData[SNIPER_HARASSING_SHOTS] == 0):
			return false

		return true
		

	# Returns true if the sniper can perform the harass function false 
	# otherwise.	
	def canSniperHarass(self, objSniper):

		# Return false if the harassing feature is not enabled
		if(not g_bEnableSniperHarassing):
			return false 
			
		# Return false immediately if the sniper passed in is invalid
		if(objSniper == None):
			return false

		# Return false immediately if the sniper passed in is invalid
		if(objSniper.isNone()):
			return false
	
		# Return false if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return false

		if(not self.canSniperHarassUnits(objSniper)):
			return false			

		# Get the sniper data
		sniperData = self.getSniperData(objSniper)

		# Return false if the sniper is already harassing			
		if(sniperData[SNIPER_HARASSING]):
			return false

		return true
	

	# Returns true if the sniper can take a shot, false otherwise.	
	def canSniperTakeShot(self, objSniper):
	
		# Return false immediately if the sniper passed in is invalid
		if(objSniper == None):
			return false

		# Return false immediately if the sniper passed in is invalid
		if(objSniper.isNone()):
			return false
	
		# Return false if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return false
	
		# Return false if the sniper can't move
		if(not objSniper.canMove()):
			return false
			
		# Return false if the sniper is already harassing
		if(self.isSniperHarassingEnabled(objSniper)):
			return false

		# Return false if the sniper isn't awake
		if(objSniper.getGroup().getActivityType() != ActivityTypes.ACTIVITY_AWAKE):
			return false

		return true			
									
	
	# Returns the list of plots that are valid and within the range passed in
	# for the sniper passed in.
	def getSniperTargetPlots(self, objSniper, iRange):
		sniperTargetPlotList = []
		
		# Return an empty list immediately if the sniper passed in is invalid
		if(objSniper == None):
			return []

		# Return an empty list immediately if the sniper passed in is invalid
		if(objSniper.isNone()):
			return []
		
		# Return an empty list immediately if the range passed in is invalid
		if(iRange <= 0):
			return []
		
		# Get the plot the sniper is on
		objSniperPlot = objSniper.plot()

		# Get the snipers owner's team
		iPlayerTeam = gc.getPlayer(objSniper.getOwner()).getTeam()
		
		# Calculate the extents of plots to check
		iMinX = objSniperPlot.getX() - iRange
		iMaxX = objSniperPlot.getX() + iRange + 1
		iMinY = objSniperPlot.getY() - iRange
		iMaxY = objSniperPlot.getY() + iRange + 1
	
		# Go through the x values of plots to check
		for iX in range(iMinX, iMaxX):
			# Go through the y values of plots to check
			for iY in range(iMinY, iMaxY):

				# Continue on to the next plot if the current x,y value pair is
				# for the plot the sniper is on.
				if(iX == objSniperPlot.getX() and iY == objSniperPlot.getY()):
					continue
				
				# Continue on to the next plot if the Y value is negative
				if(iY < 0):
					continue
					
				# Continue on to the next plot if the Y value is greater than
				# the height of the map
				if(iY > gc.getMap().getGridHeight()):
					continue
	
				# Get the actual plot on the map using the x,y value pair				
				objTargetPlot = CyMap().plot(iX, iY)

				# Continue on if the target plot isn't revealed to the player
				if(not objTargetPlot.isRevealed(iPlayerTeam, false)):
					continue

				# Continue on if the plot isn't visible to the player
				if(not objTargetPlot.isVisible(iPlayerTeam, false)):
					continue

				# Append the plot to the target plot list if the line of sight
				# to the plot isn't blocked.
				if(not self.isLineOfSightBlocked(objSniperPlot,objTargetPlot)):
					sniperTargetPlotList.append(objTargetPlot)

		return sniperTargetPlotList
	
	
	# Returns true if the line of sight from plot a to plot b is blocked, 
	# otherwise it will return false.
	def isLineOfSightBlocked(self, objPlotA, objPlotB):
	
		# Return true immediately if plot A is invalid
		if(objPlotA == None):
			return true
			
		# Return true immediately if plot B is invalid
		if(objPlotB == None):
			return true
			
		# Return false immediately if the mod is configured to allow snipers to
		# see through terrain
		if(g_bSnipersSeeThroughTerrain):
			return false
			
		# Get the list of plots between plot A and plot B.
		plotList = self.getInbetweenPlotList(objPlotA, objPlotB)		

		# Return true immediately if plot B has hills and plot A does not. This
		# will simulate the higher ground cases.
		if(objPlotB.isHills() and not objPlotA.isHills()):
			return true

		# Return true immediately if plot B has hills and a forests.
		if(objPlotB.getFeatureType() == gc.getInfoTypeForString("FEATURE_FOREST") and objPlotB.isHills()):
			return true
		
		# Return true immediately if plot B has jungles and plot A does not 
		# have hills.
		if(objPlotB.getFeatureType() == gc.getInfoTypeForString("FEATURE_JUNGLE") and not objPlotA.isHills()):
			return true

		# Return true immediately if plot B has forests and plot A does not
		# have hills.
		if(objPlotB.getFeatureType() == gc.getInfoTypeForString("FEATURE_FOREST") and not objPlotA.isHills()):
			return true

		# Return true immediately if plot B has peaks
		if(objPlotB.isPeak()):
			return true

		# Return false immediately If there are no plots between plot A and B
		if(len(plotList) == 0):
			return false

		# Go through all the plots between plot A and B
		for objTargetPlot in plotList:

			# Return true immediately if the target plot has hills and plot A 
			# does not. This will simulate the higher ground cases.
			if(objTargetPlot.isHills() and not objPlotA.isHills()):
				return true

			# Return true immediately if plot B has hills and a forest.
			if(objTargetPlot.getFeatureType() == gc.getInfoTypeForString("FEATURE_FOREST") and objTargetPlot.isHills()):
				return true

			# Return true immediately if the target plot has jungles and plot A 
			# does not have hills.
			if(objTargetPlot.getFeatureType() == gc.getInfoTypeForString("FEATURE_FOREST") and not objPlotA.isHills()):
				return true

			# Return true immediately if the target plot has forests and plot 
			# A does not have hills.
			if(objTargetPlot.getFeatureType() == gc.getInfoTypeForString("FEATURE_JUNGLE") and not objPlotA.isHills()):
				return true

			# Return true immediately if the target plot has peaks
			if(objTargetPlot.isPeak()):
				return true

		return false
	

	# Returns the list of plots between plot a and plot b.
	def getInbetweenPlotList(self, objPlotA, objPlotB):
		' plotList - the list of plots between plot a and b'
		
		plotList = []
		
		# Return an empty list immediately if plot A is invalid
		if(objPlotA == None):
			return []

		# Return an empty list immediately if plot B is invalid
		if(objPlotB == None):
			return []
		
		# Get the vector direction between plot a and plot b
		vX, vY = TheLopezUtils.getPlotToPlotVector(objPlotA, objPlotB)

		# Get the distance between plot a and plot b
		iDistance = TheLopezUtils.getPlotDistance(objPlotA, objPlotB)
		
		# Debug Code - Start
		#if(g_bDebug):
		#	self.printDebugMessage("getInbetweenPlotList: objPlotA(%s,%s), objPlotB(%s, %s) distance %s" %(objPlotA.getX(), objPlotA.getY(), objPlotB.getX(), objPlotB.getX(), iDistance))			
		# Debug Code - End

		# Go through all the plots between plot a and plot b and add them to
		# the plotList
		for i in range(1, iDistance):
			iX = objPlotA.getX() - (vX * i)
			iY = objPlotA.getY() - (vY * i)
			plotList.append(CyMap().plot(iX, iY))
			
			# Debug Code - Start
			#if(g_bDebug):
			#	self.printDebugMessage("getInbetweenPlotList: plot[%s] (%s,%s)" %(i,iX,iY))				
			# Debug Code - End

		return plotList
		

	# Returns the number of valid sniper targets
	def getSniperTargetCount(self, objSniper, objPlot):
		
		iUnitCount = 0

		# Return 0 immediately if the plot passed in is invalid
		if(objPlot == None):
			return 0		

		# Return 0 immediately if the plot is a city and the mod is configured
		# to not allow snipers to target cities.		
		if(objPlot.isCity() and not g_bAllowSniperTargetCities):
			return 0
		
		# Get the owner of the sniper
		iPlayer = objSniper.getOwner()
		
		# Go through the units in the plot
		for i in range(objPlot.getNumUnits()):
			objTargetUnit = objPlot.getUnit(i)

			
			# Try to count the unit if it doesn't belong to the player
			if(objTargetUnit.getOwner() != iPlayer):
			
				# Count the unit if it isn't a sniper
				if(objTargetUnit.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
					iUnitCount += 1
	
				# Count the unit if it is a sniper and it is visible
				elif(objTargetUnit.getUnitCombatType() == gc.getInfoTypeForString("UNITCOMBAT_SNIPER") and objTargetUnit.plot().isInvisibleVisible(objSniper.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER"))):
					iUnitCount += 1
		
		# If the plot is a city then get the count of non-unit valid sniper
		# targets
		if(objPlot.isCity()):
			iUnitCount += self.getSniperNonUnitTargetCount(objPlot)
		
		return iUnitCount
		
		
	# Returns the number of valid non-unit sniper targets
	def getSniperNonUnitTargetCount(self, objPlot):
		
		iUnitCount = 0
		
		# Return 0 immediately if the plot passed in is invalid
		if(objPlot == None):
			return 0
	
		# Return 0 immediately if the plot passed in does not contain a city.
		if(not objPlot.isCity()):
			return 0
			
		# Return 0 immediately if the mod is configured to not allow snipers 
		# to target cities.		
		if(not g_bAllowSniperTargetCities):
			return 0
		
		# Get the city in the plot
		objCity = objPlot.getPlotCity()
		
		# Add one to the unit count if the mod is configured to allow snipers
		# to terrorize the citizens of a city.
		if(g_bAllowSniperTerrorizeCitizens):
			iUnitCount += 1
			
		# Add the number of specialists in a city if the mod is configured to
		# allow snipers to target specialists.			
		if(g_bAllowSniperTargetSpecialists):
			for i in range( gc.getNumSpecialistInfos() ):
				iUnitCount += objCity.getSpecialistCount(i)

		# Add the number of super specialists in a city if the mod is 
		# configured to allow snipers to target super specialists
		if(g_bAllowSniperTargetSuperSpecialists):
			for i in range(gc.getNumSpecialistInfos()):
				iUnitCount += objCity.getFreeSpecialistCount(i)

		return iUnitCount
		
				
	# Sets the unit to face the plot passed in.
	def setUnitFacingDirection(self, objUnit, objTargetPlot):
		
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return
			
		# Return immediately if the target plot passed in is invalid
		if(objTargetPlot == None):
			return

		# Return immediately if the target plot passed in is invalid
		if(objTargetPlot.isNone()):
			return

		# Get the unit entity that represents the unit in the game.			
		objUnitEntity = CyUnitEntity(objUnit)
		
		# Get the plot the unit is on
		objUnitPlot = objUnit.plot()
		
		dX = float(objTargetPlot.getPoint().x - objUnitPlot.getPoint().x)
		dY = float(objUnitPlot.getPoint().y - objTargetPlot.getPoint().y)
		
		dDirection = 0
		
		# Some terse calculations, if you have questions look up radian 
		# calculations in google
		if( dY > 0):
			dDirection = math.atan(dX / dY) * -1
		elif( dY < 0): 
			dDirection = (math.atan(dX / dY) + math.pi) * -1
		elif( dY == 0 ):
			dDirection = (math.atan(dX) + math.pi)

		# Change the direction the unit is facing
		objUnitEntity.SetUnitFacingDirection(dDirection)		
		
		
	# Gives the sniper unit passed in experience
	def giveExperience(self, objSniper, bFatalShot):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
			
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		bGiveExperience = bFatalShot

		# If the mod is configured to give experience points for all successful
		# shots then flip the give experience variable
		if(g_bAllShotsGiveExperience):
			bGiveExperience = true

		# Give the sniper unit its new experience
		if(bGiveExperience):
			# Debug Code - Start
			if(g_bDebug):
				self.printDebugMessage("Exp/Shot: %s Shot fatal? %s All shots give XP? %s"  %(g_iExperiencePerSuccessfulShot,bFatalShot,g_bAllShotsGiveExperience ))
			# Debug Code - end

			# Give the sniper their hard earned experience points.
			objSniper.setExperience(objSniper.getExperience()+g_iExperiencePerSuccessfulShot, objSniper.getExperience()+g_iExperiencePerSuccessfulShot)

			# If the future experience level for the sniper unit is enough to level
			# unit flip the promotion ready flag.
			if(objSniper.getExperience() >= objSniper.experienceNeeded()):
				objSniper.setPromotionReady(true)

			if(not gc.getPlayer(objSniper.getOwner()).isHuman()):
				iSniperPromotionChance = gc.getGame().getMapRand().get(100,"Promo")
				if(iSniperPromotionChance > 49):
					sniperPromotionList = ["PROMOTION_AIM1","PROMOTION_AIM2","PROMOTION_AIM3","PROMOTION_AIM4","PROMOTION_AIM5","PROMOTION_FATAL_SHOT1","PROMOTION_FATAL_SHOT2","PROMOTION_FATAL_SHOT3","PROMOTION_OBFUSCATION1","PROMOTION_OBFUSCATION2","PROMOTION_OBFUSCATION3"]
					for strPromotion in sniperPromotionList:
						iPromotion = gc.getInfoTypeForString(strPromotion)
						if(not objSniper.isHasPromotion(iPromotion)):

							objSniper.setHasPromotion(iPromotion, true)
							objSniper.setLevel(objSniper.getLevel()+1)
							objSniper.setPromotionReady(false)
							return
				
		# Flip the dirty bits in the main interface to force a screen redraw
		CyInterface().setDirty(InterfaceDirtyBits.InfoPane_DIRTY_BIT, true)
		CyInterface().setDirty(InterfaceDirtyBits.SelectionButtons_DIRTY_BIT, true)


	# Randomly gives an AI sniper a sniper promotion if they are ready to be 
	# promoted
	def AI_giveSniperPromotion(self, objSniper):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
			
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		# Return immediately if the sniper passed has a human owner
		if(gc.getPlayer(objSniper.getOwner()).isHuman()):
			return
			
		# Calculate the sniper promotion chance
		iSniperPromotionChance = gc.getGame().getMapRand().get(100,"Promo")

		# Return if the sniper promotion chance is greater than 50
		if(iSniperPromotionChance < 50):
			return
		
		sniperPromotionList = ["PROMOTION_AIM1","PROMOTION_AIM2","PROMOTION_AIM3","PROMOTION_AIM4","PROMOTION_AIM5","PROMOTION_FATAL_SHOT1","PROMOTION_FATAL_SHOT2","PROMOTION_FATAL_SHOT3","PROMOTION_OBFUSCATION1","PROMOTION_OBFUSCATION2","PROMOTION_OBFUSCATION3"]
				
		# Go through each one of the sniper promotions
		for strPromotion in sniperPromotionList:
			
			# Get the ID for the sniper promotion
			iPromotion = gc.getInfoTypeForString(strPromotion)

			# If the sniper doesn't have the promotion then give it to the 
			# sniper and return
			if(not objSniper.isHasPromotion(iPromotion)):
				objSniper.setHasPromotion(iPromotion, true)
				objSniper.setLevel(objSniper.getLevel()+1)
				objSniper.setPromotionReady(false)
				return


	# Refreshes the sniper information by resetting the sniper harassment 
	# shots and making the plot the sniper is on provide invisibility to the
	# sniper against all other teams.
	def refreshSniper(self, objSniper):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
			
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return

		# Construct the sniper ID
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		# Setup the sniper data if it doesn't exist and return
		if(not sdEntityExists("SniperMod", strSniperID)):
			self.setupSniperData(objSniper)
			return
			
		# Get the sniper data
		sniperData = sdGetVal("SniperMod", strSniperID, SNIPER_DATA)
		
		# Get the snipers current plot from the sniper data
		objCurrentPlot = sniperData[NEW_PLOT]

		# If the current plot is None then fix it
		if(objCurrentPlot == None):
			objCurrentPlot = (objSniper.plot().getX(),objSniper.plot().getY())
			sniperData[NEW_PLOT] = objCurrentPlot
			
		# Refresh the sniper harassing shots			
		sniperData[SNIPER_HARASSING_SHOTS] = g_iSniperHarassShotCount
		
		# Save the refreshed sniper data
		sdSetVal("SniperMod", strSniperID, SNIPER_DATA, sniperData)
		
		# Get the actual plot the sniper is on
		objPlot = gc.getMap().plot(objCurrentPlot[0],objCurrentPlot[1])
		
		# If the plot has a sniper then make sure the snipers are invisible to 
		# all the other players
		if(self.plotHasPlayerSniper(objPlot,objSniper.getOwner())):

			# Get all the players in the game
			playerList = PyGame.getCivPlayerList()

			# Go through all the players in the game
			for objPlayer in playerList:
			
				# Get the CyPlayer instance of the player
				objPlayer = objPlayer.CyGet()
				
				# If the sniper is visible to the current player then make the 
				# sniper invisible to that player
				if(objPlot.isInvisibleVisible(objPlayer.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER"))):
				
					iInvisibleCount = objPlot.getInvisibleVisibilityCount(objPlayer.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER")) * -1
					objPlot.changeInvisibleVisibilityCount(objPlayer.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER"),iInvisibleCount)
			
			
	# Get the discovery chance for the spotter passed in
	def getDiscoveryChance(self, objSpotter):

		# Return 0 immediately if the spotter unit passed in is invalid
		if(objSpotter == None):
			return 0
			
		# Return 0 immediately if the spotter unit passed in is invalid
		if(objSpotter.isNone()):
			return 0
		
		# Set the base discovery chance
		iDiscoveryChance = objSpotter.getLevel()*7 + (objSpotter.getExtraObfuscationChance()/2)

		# If the spotter is a sniper then increase the chance that the spotter 
		# will discover a sniper
		if(objSpotter.getUnitCombatType() == gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			iDiscoveryChance = iDiscoveryChance + (g_iBaseSniperObfuscation/2)
			
			# Increase the chance even more if the spotter is a sniper and they 
			# have been trained at a sniper school	
			if(objSpotter.isHasPromotion(gc.getInfoTypeForString("PROMOTION_SNIPER"))):
				iDiscoveryChance = iDiscoveryChance + (g_iBaseSniperObfuscation/2)
			
		return iDiscoveryChance			
			

	# Performs the scan operation for the unit passed in
	def scanForSniper(self, objUnit):

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return
		
		# Get the list of adjacent plots to the unit
		plotList = self.getAdjacentPlots(objUnit)

		# Get the discovery chance for the unit
		iDiscoveryChance = self.getDiscoveryChance(objUnit)

		# Go through the plots
		for objPlot in plotList:

			# Get the units found in the current plot
			unitList = TheLopezUtils.getPlotUnitList(objPlot)
			
			# Go through the units in the current plot
			for objTargetUnit in unitList:

				# Continue if the current unit isn't a sniper
				if(objTargetUnit.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
					continue
				
				# If a unit is sniper, the sniper is discovered and they are 
				# not visible then make them visible to the owner of the unit 
				# that found them
				if(self.isSniperDiscovered(objTargetUnit, iDiscoveryChance) and not objPlot.isInvisibleVisible(objTargetUnit.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER"))):
					objPlot.changeInvisibleVisibilityCount(objUnit.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER"),1)
					# Debug Code - Start
					if(g_bDebug):
						self.printDebugMessage("Sniper discovered")			
					# Debug Code - End


	# Returns the obfuscation chance for the sniper passed in
	def getObfuscationChance(self, objSniper):
	
		# Return 0 immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return 0
			
		# Return 0 immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return 0
		
		# Return 0 immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return 0

		iObfuscationChance = g_iBaseSniperObfuscation + objSniper.getExtraObfuscationChance()
		
		# Get the plot the sniper is on
		objSniperPlot = objSniper.plot()
		
		# If the mod is configured to allow forests to affect obfuscation and 
		# the sniper is on a plot with a forest then increase their obfuscation 
		# chance
		if(g_bForestsAffectObfuscation and objSniperPlot.getFeatureType() == gc.getInfoTypeForString("FEATURE_FOREST")):
	 		iObfuscationChance += g_iForestObfuscationEffectAmount

		# If the mod is configured to allow jungles to affect obfuscation and 
		# the sniper is on a plot with a jungle then increase their obfuscation 
		# chance
		if(g_bJunglesAffectObfuscation and objSniperPlot.getFeatureType() == gc.getInfoTypeForString("FEATURE_JUNGLE")):
	 		iObfuscationChance += g_iForestObfuscationEffectAmount

		# If the mod is configured to allow hills to affect obfuscation and the 
		# sniper is on a plot with hills then increase their obfuscation chance
		if(g_bHillsAffectObfuscation and objSniperPlot.isHills()):
	 		iObfuscationChance += g_iHillObfuscationEffectAmount

		return iObfuscationChance
		
	
	# Returns true if the sniper was discovered false otherwise
	def isSniperDiscovered(self, objSniper, iDiscoveryChance):

		# Return false immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return false
		
		# Return false immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return false
			
		# Return false immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return false
		
		# Get the snipers obfuscation chance
		iObfuscationChance = self.getObfuscationChance(objSniper)
		
		# Calculate the obfuscation result
		iObfuscationtResult = gc.getGame().getMapRand().get(iDiscoveryChance, "Obfuscation")

		# Get the sniper data
		objSniperData = self.getSniperData(objSniper)

		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())

		# Set the sniper as discovered if the obfuscation result is bigger than 
		# the obfuscation chance
		objSniperData[DISCOVERED] = (iObfuscationChance<iObfuscationtResult)

		# Save the objfuscation result
		objSniperData[LAST_OBFUSCATION_RESULT] = iObfuscationtResult
		
		# Save the sniper data
		sdSetVal("SniperMod",strSniperID, SNIPER_DATA, objSniperData)

		# Debug Code - Start
		if(g_bDebug):
			self.printDebugMessage("iObfuscationChance>iObfuscationtResult:iDiscoveryChance = %s/%s:%s = %s last plot (%s,%s)" %(iObfuscationChance, iObfuscationtResult,iDiscoveryChance,(iObfuscationChance<iObfuscationtResult),objSniperData[NEW_PLOT][0],objSniperData[NEW_PLOT][1]))
		# Debug Code - End
		
		return (iObfuscationChance<iObfuscationtResult)
		

	# Reverts the invisibility of a plot a sniper has moved out of if they were 
	# the only sniper there.
	def fixOldPlot(self, objSniper):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
		
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		# Return immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return

		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())

		# Setup the sniper data if it doesn't exist and return	
		if(not sdEntityExists("SniperMod", strSniperID)):
			self.setupSniperData(objSniper)
			return

		# Get the sniper data			
		sniperData = sdGetVal("SniperMod", strSniperID, SNIPER_DATA)
		
		# Get the old sniper plot data
		objOldPlot = sniperData[OLD_PLOT]
		
		# Return if the old plot data is invalid
		if(objOldPlot == None):
			return
				
		# Get the actual instance of the old plot
		objPlot = gc.getMap().plot(objOldPlot[0],objOldPlot[1])
		
		# Check to see if the old plot contains a sniper belonging to the 
		# player
		if(self.plotHasPlayerSniper(objPlot,objSniper.getOwner())):

			# Get the list of players in the game
			playerList = PyGame.getCivPlayerList()

			# Go through the list of players in the game
			for objPlayer in playerList:
				
				# Get the CyPlayer instance of the player
				objPlayer = objPlayer.CyGet()

				# If the sniper is visible to the current player then make the 
				# sniper invisible to that player
				if(objPlot.isInvisibleVisible(objPlayer.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER"))):
				
					iInvisibleCount = objPlot.getInvisibleVisibilityCount(objPlayer.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER")) * -1
					objPlot.changeInvisibleVisibilityCount(objPlayer.getTeam(), gc.getInfoTypeForString("INVISIBLE_SNIPER"),iInvisibleCount)
	
	
	# Returns true if the plot passed in has a sniper owned by the player 
	# passed in
	def plotHasPlayerSniper(self, objPlot, iPlayer):

		# Return false immediately if the plot passed in is invalid
		if(objPlot == None):
			return false
		
		# Return false immediately if the plot passed in is invalid
		if(objPlot.isNone()):
			return false
	
		# Get the unit list for the plot passed in
		unitList = TheLopezUtils.getPlayerPlotUnitList(objPlot,iPlayer)
		
		# Go through each of the units in the plot
		for objUnit in unitList:

			# Return true if the current unit is a sniper
			if(objUnit.getUnitCombatType() == gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
				return true
						
		return false


	# Returns the list of valid targets for the sniper
	def getSniperTargets(self, objSniper):
		
		sniperTargetList = []
		
		# Return an empty list immediately if the sniper passed in is invalid
		if(objSniper == None):
			return []

		# Return an empty list immediately if the sniper passed in is invalid
		if(objSniper.isNone()):
			return []

		# Return an empty list immediately if the unit passed in isn't a sniper			
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return []

		# Get the snipers team
		objSniperTeam = gc.getTeam(objSniper.getTeam())
		
		# Get the snipers range
		iRange = objSniper.getExtraVisibilityRange()
		
		# Return immediately if the range passed in is invalid		
		if(iRange <= 0):
			iRange = 1
		
		# Get the valid plots for the sniper		
		sniperTargetPlotList = self.getSniperTargetPlots(objSniper, iRange)
		
		# Go through the plots
		for objPlot in sniperTargetPlotList:

			# Get the unit list for the current plot
			unitList = TheLopezUtils.getPlotUnitList(objPlot)	

			# Go through each of the units in the list
			for objUnit in unitList:
				# Add the unit to the sniper target list if the owner of the 
				# sniper is at war with the owner of the current unit.
				if(objSniperTeam.isAtWar(objUnit.getTeam())):
					sniperTargetList.append(objUnit)
		
		return sniperTargetList
		
		
	# Returns true if the sniper passed in has their harass function enabled.
	def isSniperHarassingEnabled(self, objSniper):

		# Return false immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return false
		
		# Return false immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return false
			
		# Return false immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return false
			
		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		# Setup the sniper data if it doesn't exist and return
		if(not sdEntityExists("SniperMod", strSniperID)):
			self.setupSniperData(objSniper)
			return false

		# Get the sniper data			
		sniperData = sdGetVal("SniperMod", strSniperID, SNIPER_DATA)

		# If the sniper is currently awake then they should not have their
		# harassment function enabled
		if(objSniper.getGroup().getActivityType() == ActivityTypes.ACTIVITY_AWAKE):
			self.disableSniperHarassing(objSniper)
			
		return sniperData[SNIPER_HARASSING]
		
	
	# Enables the sniper harassment function		
	def enableSniperHarassing(self, objSniper):
	
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
		
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		# Return immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return
			
		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		# Setup the sniper data if it doesn't exist
		if(not sdEntityExists("SniperMod", strSniperID)):
			self.setupSniperData(objSniper)

		# Get the sniper data			
		sniperData = sdGetVal("SniperMod", strSniperID, SNIPER_DATA)

		# Set the sniper as harassing
		sniperData[SNIPER_HARASSING] = true
	
		# Reset the sniper shots 
		sniperData[SNIPER_HARASSING_SHOTS] = g_iSniperHarassShotCount

		# Save the sniper data
		sdSetVal("SniperMod", strSniperID, SNIPER_DATA, sniperData)


	# Disables the sniper harassment function		
	def disableSniperHarassing(self, objSniper):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
		
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		# Return immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return
			
		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		# Setup the sniper data if it doesn't exist and return
		if(not sdEntityExists("SniperMod", strSniperID)):
			self.setupSniperData(objSniper)
			return

		# Get the sniper data			
		sniperData = sdGetVal("SniperMod", strSniperID, SNIPER_DATA)

		# Set the sniper as not harassing
		sniperData[SNIPER_HARASSING] = false
	
		# Save the sniper data
		sdSetVal("SniperMod", strSniperID, SNIPER_DATA, sniperData)

	
	# Returns true if the sniper hits the intended target in the plot passed in
	def isTargetHit(self, objSniper, objTargetPlot):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return false
		
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return false
						
		# Return immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return false

		# Return immediately if the plot passed in is invalid
		if(objTargetPlot == None):
			return false
		
		# Return immediately if the plot passed in is invalid
		if(objTargetPlot.isNone()):
			return false			
			
		iHitChance = g_iBaseSniperAim + objSniper.getExtraAim()
		
		iResultMax = 100
		
		# Get the snipers plot
		objSniperPlot = objSniper.plot()
		
		# Get the distance between the sniper plot and target plot
		iDistance = TheLopezUtils.getPlotDistance(objSniperPlot, objTargetPlot)
		
		# If the target is one plot away then increase the hit chance.
		if(iDistance == 1):
			iHitChance+=10
			
		# Calculate the max result
		iResultMax = iResultMax + ((iDistance-2)*10)
		
		# Calculate the hit result
		iHitResult = gc.getGame().getMapRand().get(iResultMax, "Hit Chance")			

		# If the target plot contains a city then increase the hit result 
		# accordingly.
		if(objTargetPlot.isCity()):
			
			# If the target city has walls then increase the hit result
			if(objTargetPlot.getPlotCity().hasBuilding(gc.getInfoTypeForString("BUILDING_WALLS"))):
				iHitResult += 20
			
			# If the target city has a castle then increase the hit result
			if(objTargetPlot.getPlotCity().hasBuilding(gc.getInfoTypeForString("BUILDING_CASTLE"))):
				iHitResult += 10

		# Debug code - start
		if(g_bDebug):
			self.printDebugMessage("iHitChance>iHitResult= %s>%s  iResultMax: %s" %(iHitChance,iHitResult,iResultMax))
		# Debug code - end

		return (iHitChance>iHitResult)
		
			
	# Returns true if the snipers shot is fatal, false otherwise
	def isShotFatal(self, objSniper):

		# Return false immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return false
		
		# Return false immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return false
			
		# Return false immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return false

		iFatalShotChance = g_iBaseSniperFatalShot + objSniper.getExtraFatalShotChance()
			
		# Calculate the fatal shot result
		iFatalShotResult = gc.getGame().getMapRand().get(100, "Fatal Shot")			

		return (iFatalShotChance>iFatalShotResult)

	
	# Missed shot by the sniper
	def missedShot(self, objSniper):
	
		# Return immediately if the sniper passed in is invalid
		if(objSniper == None):
			return

		# Return immediately if the sniper passed in is invalid
		if(objSniper.isNone()):
			return
		
		# Get the in-game entity for the unit passed in.
		objUnitEntity = CyUnitEntity(objSniper)

		objUnitEntity.GetSubEntity(0).PlayAnimationPath(AnimationPathTypes.ANIMATIONPATH_MELEE_STRIKE)

		if(objSniper.isHasPromotion(gc.getInfoTypeForString("PROMOTION_SNIPER"))):
			objSniper.setMoves(objSniper.getMoves()+60)
		else:
			objSniper.finishMoves()
		
		strMessage = localText.getText("TXT_KEY_TARGET_MISSED", ())
		CyInterface().addImmediateMessage(strMessage,"") 
		return


	# Wastes a shot by the sniper.		
	def wasteShot(self, objSniper):
		
		# Return immediately if the sniper passed in is invalid
		if(objSniper == None):
			return

		# Return immediately if the sniper passed in is invalid
		if(objSniper.isNone()):
			return
		
		# Get the in-game entity for the unit passed in.
		objUnitEntity = CyUnitEntity(objSniper)

		if(g_bAllowSniperWasteShot):
			objUnitEntity.GetSubEntity(0).PlayAnimationPath(AnimationPathTypes.ANIMATIONPATH_MELEE_STRIKE)	

			if(objSniper.isHasPromotion(gc.getInfoTypeForString("PROMOTION_SNIPER"))):
				objSniper.setMoves(objSniper.getMoves()+60)
			else:
				objSniper.finishMoves()
			
		strMessage = localText.getText("TXT_KEY_NO_SNIPER_TARGET", ())
		CyInterface().addImmediateMessage(strMessage,"") 
		return
					
			
	# Returns the data for the sniper passed in
	def getSniperData(self, objSniper):

		# Return None immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return None
		
		# Return None immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return None
			
		# Return None immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return None

		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		# Setup the sniper data if it doesn't exist
		if(not sdEntityExists("SniperMod", strSniperID)):
			self.setupSniperData(objSniper)

		return sdGetVal("SniperMod", strSniperID, SNIPER_DATA)
		
	
	# Updates the sniper data by updating the snipers old and new plot 
	# information.
	def updateSniperData(self, objSniper):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
		
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		# Return immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return

		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		# Setup the sniper data if it doesn't exist and return
		if(not sdEntityExists("SniperMod", strSniperID)):
			self.setupSniperData(objSniper)
			return
			
		# Get the sniper data
		sniperData = sdGetVal("SniperMod", strSniperID, SNIPER_DATA)
		
		# Set the old sniper plot with the new sniper plot data
		sniperData[OLD_PLOT] = sniperData[NEW_PLOT]
		
		# Create the new sniper plot information from the snipers current plot
		newPlotPoint = (objSniper.plot().getX(),objSniper.plot().getY())
		
		# Set the new sniper plot data
		sniperData[NEW_PLOT] = newPlotPoint
		
		# Update the sniper so it isn't harassing, this is needed since the 
		# sniper moved.
		sniperData[SNIPER_HARASSING] = false
		
		# Set the sniper data
		sdSetVal("SniperMod",strSniperID, SNIPER_DATA, sniperData)
				
				
	# Deleted the sniper data from the game
	def deleteSniperData(self, objSniper):

		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
		
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		# Return immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return

		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		# Return if sniper data doesn't exist
		if(not sdEntityExists("SniperMod", strSniperID)):
			return

		# Remove the sniper data from the game
		sdEntityWipe("SniperMod", strSniperID)


	# Sets up the initial sniper data if it doesn't exist.
	def setupSniperData(self, objSniper):
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper == None):
			return
		
		# Return immediately if the sniper unit passed in is invalid
		if(objSniper.isNone()):
			return
			
		# Return immediately if the unit passed in isn't a sniper
		if(objSniper.getUnitCombatType() != gc.getInfoTypeForString("UNITCOMBAT_SNIPER")):
			return

		# Build the sniper ID string
		strSniperID = str(objSniper.getOwner()) + "-" + str(objSniper.getID())
	
		oldPlotPoint = None

		# Create the new sniper plot information from the snipers current plot
		newPlotPoint = (objSniper.plot().getX(),objSniper.plot().getY())
		
		# Create the sniper data dictionary that will be set
		masterSniperData = { SNIPER_DATA : { OWNER_ID : objSniper.getOwner(),
						SNIPER_ID : objSniper.getID(),
						OLD_PLOT : oldPlotPoint,
						NEW_PLOT : newPlotPoint,
						DISCOVERED : false,						
						LAST_OBFUSCATION_RESULT : -1,
						SNIPER_HARASSING: false,
						SNIPER_HARASSING_SHOTS: g_iSniperHarassShotCount
						 } }
						 
		# Setup the sniper data in the game.
		sdEntityInit("SniperMod", strSniperID, masterSniperData)


	# Prints the debug message to the logs, screen or both	
	def printDebugMessage(self, strMessage):
	
		if(g_iDebugMessageTarget == LOG_ONLY):
			CvUtil.pyPrint(strMessage)
		elif(g_iDebugMessageTarget == SCREEN_ONLY):
			CyInterface().addImmediateMessage(strMessage,"")
		else:
			CvUtil.pyPrint(strMessage)
			CyInterface().addImmediateMessage(strMessage,"")
			
			